/*  PS2Keyboard library example
  
  PS2Keyboard now requries both pins specified for begin()

  keyboard.begin(data_pin, irq_pin);
  
  Valid irq pins:
     Arduino Uno:  2, 3
     Arduino Due:  All pins, except 13 (LED)
     Arduino Mega: 2, 3, 18, 19, 20, 21
     Teensy 2.0:   All pins, except 13 (LED)
     Teensy 2.0:   5, 6, 7, 8
     Teensy 1.0:   0, 1, 2, 3, 4, 6, 7, 16
     Teensy++ 2.0: 0, 1, 2, 3, 18, 19, 36, 37
     Teensy++ 1.0: 0, 1, 2, 3, 18, 19, 36, 37
     Sanguino:     2, 10, 11
  
  for more information you can read the original wiki in arduino.cc
  at http://www.arduino.cc/playground/Main/PS2Keyboard
  or http://www.pjrc.com/teensy/td_libs_PS2Keyboard.html
  
  Like the Original library and example this is under LGPL license.
  
  Modified by Cuninganreset@gmail.com on 2010-03-22
  Modified by Paul Stoffregen <paul@pjrc.com> June 2010
*/
   
#include <PS2Keyboard.h>;
const int DataPin = 3;
const int IRQpin =  2;
PS2Keyboard keyboard;
#define d0 4
#define d1 5
#define d2 6
#define d3 7
#define d4 8
#define d5 9
#define d6 10
#define reset 12
#define strobe 13
int x = 0;

void setup() {
        delay (1000);    
        // keyboard.begin(DataPin, IRQpin, PS2Keymap_US);
        // keyboard.begin(DataPin, IRQpin, PS2Keymap_German);
        keyboard.begin(DataPin, IRQpin, PS2Keymap_French);
        pinMode(d0, OUTPUT);
	pinMode(d1, OUTPUT);
	pinMode(d2, OUTPUT);
	pinMode(d3, OUTPUT);
	pinMode(d4, OUTPUT);
	pinMode(d5, OUTPUT);
	pinMode(d6, OUTPUT);
	pinMode(strobe, OUTPUT);
	pinMode(reset, OUTPUT);
	//digitalWrite(reset,HIGH);
	//digitalWrite(strobe,LOW);

 // Serial.begin(9600);
 // Serial.println("Keyboard Test:");
  
}

void loop() {
  if (keyboard.available()) {
    
    // read the next key
    char c = keyboard.read(); // char
     /* supprimer le slash et l'étoile pour voir la touche avec le moniteur série  
    // check for some of the special keys
    if (c == PS2_ENTER) {
      Serial.println();
    } else if (c == PS2_TAB) {
      Serial.print("[Tab]");
    } else if (c == PS2_ESC) {
      Serial.print("[ESC]");
    } else if (c == PS2_PAGEDOWN) {
      Serial.print("[PgDn]");
    } else if (c == PS2_PAGEUP) {
      Serial.print("[PgUp]");
    } else if (c == PS2_LEFTARROW) {
      Serial.print("[Left]");
    } else if (c == PS2_RIGHTARROW) {
      Serial.print("[Right]");
    } else if (c == PS2_UPARROW) {
      Serial.print("[Up]");
    } else if (c == PS2_DOWNARROW) {
      Serial.print("[Down]");
    } else if (c == PS2_DELETE) {
      Serial.print("[Del]");
    } else if (c == -61) {
      Serial.print("[PS2_SCROLL]"); //-61=FFFFFFC3
      //digitalWrite(reset,LOW);
      //delayMicroseconds(10000);
      //digitalWrite(reset,HIGH);
    } else {
      
      // otherwise, just print all normal characters
      Serial.print(c);
      //Serial.print(c,HEX);
      
          }
 */
    x = int(c); 
    if (x == -61) {
      digitalWrite(reset,LOW); // -61 est la valeur de la touche PS2_SCROLL
      delayMicroseconds(200); // reset de 200 µs
      digitalWrite(reset,HIGH); // on remet la broche à 1
	} else {
    if (x >= 128) {
		x = x - 128;
        } else {}
	if (x >= 64) {
		x = x - 64;
		digitalWrite(d6,HIGH);
	} else {
		digitalWrite(d6,LOW);
	}
	if (x >= 32) {
		x = x - 32;
		digitalWrite(d5,HIGH);
	} else {
		digitalWrite(d5,LOW);
	}
	if (x >= 16) {
		x = x - 16;
		digitalWrite(d4,HIGH);
	} else {
		digitalWrite(d4,LOW);
	}
	if (x >= 8) {
		x = x - 8;
		digitalWrite(d3,HIGH);
	} else {
		digitalWrite(d3,LOW);
	}
	if (x >= 4) {
		x = x - 4;
		digitalWrite(d2,HIGH);
	} else {
		digitalWrite(d2,LOW);
	}
	if (x >= 2) {
		x = x - 2;
		digitalWrite(d1,HIGH);
	} else {
		digitalWrite(d1,LOW);
	}
	if (x >= 1) {
		digitalWrite(d0,HIGH);
	} else {
		digitalWrite(d0,LOW);
	}
	digitalWrite(strobe,HIGH); // D0-D7 positionnés, on envoie le strobe pour prise en compte
	delayMicroseconds(10);
	digitalWrite(strobe,LOW);
}
}
  }
